// 在main.js上通过import引入Vue库和自己写的Vue组件库
import Vue from 'vue';
import Calendar from './components/test.vue'
import eventBus from '../../../../../../util/eventBus'
(function (KDApi) {
  function MyComponent (model) {
    this._setModel(model)
  }

  MyComponent.prototype = {
    _setModel: function (model) {
      this.model = model
    },
    init: function (props) {
      console.log('-----init1111', props.data)
      setHtml(this.model, props)
    },
    update: function (props) {
      console.log('-----update', this.model, props)
      eventBus.pub(this.model, 'update', props)
      // updateHtml(this.model, props)
    },
    destoryed: function () {
      console.log('-----destoryed', this.model)
    }
  }

  const setHtml = (model, props) => {
    const { invoke } = model
    const {dateList} = props.data ? props.data : []
    
    KDApi.loadFile('./css/index.css', model, () => {
      // console.log("22222",dateList)
      new Vue({
        el: model.dom,
        template:'<Calendar :chooseData="list" v-on:selectData="selectData"/>',
       components: {
          Calendar
        },
        data:function (){
          return {
            list:dateList
          }
        },
        mounted () {
          const self = this
          this.updateSub = eventBus.sub(model, 'update', (props) => {
            const { dateList } = props.data ? props.data : []
            console.log("updateSub",dateList)
            self.list = dateList
          })
        },
        destroyed () {
          eventBus.unsub(this.updateSub)
        },
        methods: {
          invoke: function (eventName, args) {
            invoke(eventName, args)
          },
          selectData:function(data){
            // console.log("data",data)
            this.invoke("selectData",data)
          }
        }
      })
    })
  }
  
  // 注册自定义组件
  KDApi.register('calenderYzj', MyComponent)
})(window.KDApi)
